var page_user_guide =
[
    [ "Introduction", "page_user_guide_intro.html", [
      [ "Hello, CAN!", "page_user_guide_intro.html#section_user_guide_intro_hello", null ],
      [ "Programmer's Overview", "page_user_guide_intro.html#section_user_guide_intro_programmers", null ],
      [ "Redistributable Files in CANlib SDK", "page_user_guide_intro.html#section_user_guide_intro_redistributable", null ]
    ] ],
    [ "Compatibility", "page_porting_code_older.html", null ],
    [ "Initialization", "page_user_guide_init.html", [
      [ "Library Initialization", "page_user_guide_init.html#section_user_guide_init_lib_init", null ],
      [ "Library Deinitialization and Cleanup", "page_user_guide_init.html#section_user_guide_init_lib_deinit", null ],
      [ "Chips and Channels", "page_user_guide_init.html#section_user_guide_init_sel_channel", null ],
      [ "Bit Rate and Other Bus Parameters", "page_user_guide_init.html#section_user_guide_init_bit_rate", null ],
      [ "CAN Driver Modes", "page_user_guide_init.html#section_user_guide_init_driver_modes", null ]
    ] ],
    [ "Sending and Receiving", "page_user_guide_send_recv.html", [
      [ "Bus On / Bus Off", "page_user_guide_send_recv.html#section_user_guide_send_recv_bus_on_off", null ],
      [ "Reading Messages", "page_user_guide_send_recv.html#section_user_guide_send_recv_reading", null ],
      [ "Sending Messages", "page_user_guide_send_recv.html#section_user_guide_send_recv_sending", null ],
      [ "Asynchronous Notification", "page_user_guide_send_recv.html#section_user_guide_send_recv_asynch_not", null ],
      [ "Message Filters", "page_user_guide_send_recv.html#section_user_guide_send_recv_filters", null ],
      [ "Message Mailboxes", "page_user_guide_send_recv.html#section_user_guide_send_recv_mailboxes", null ],
      [ "Overruns", "page_user_guide_send_recv.html#section_user_guide_send_recv_overruns", null ],
      [ "Message Queue and Buffer Sizes", "page_user_guide_send_recv.html#section_user_guide_send_recv_queue_and_buf_sizes", null ],
      [ "Object Buffers", "page_user_guide_send_recv.html#section_user_guide_send_recv_obj_buf", null ],
      [ "Different CAN Frame Types", "page_user_guide_send_recv.html#section_user_guide_send_recv_sending_different_types", null ]
    ] ],
    [ "Handling Bus Errors", "page_user_guide_bus_errors.html", [
      [ "Handling Bus Errors", "page_user_guide_bus_errors.html#section_user_guide_bus_errors_error_frames", null ],
      [ "SJA1000 Error Codes", "page_user_guide_bus_errors.html#section_user_guide_bus_errors_sja1000_error_codes", null ]
    ] ],
    [ "Using Threads", "page_user_guide_threads.html", [
      [ "Threaded Applications", "page_user_guide_threads.html#section_user_guide_threads_applications", null ]
    ] ],
    [ "Getting and Setting Device Information", "page_user_guide_dev_info.html", [
      [ "Obtaining Special Information", "page_user_guide_dev_info.html#section_user_guide_dev_info_special", null ],
      [ "Obtaining Status Information", "page_user_guide_dev_info.html#section_user_guide_dev_info_status", null ]
    ] ],
    [ "Virtual Channels", "page_user_guide_virtual.html", null ],
    [ "Time Measurement", "page_user_guide_time.html", [
      [ "Time Measurement", "page_user_guide_time.html#section_user_guide_time_general", null ],
      [ "Time Stamping Accuracy and Resolution", "page_user_guide_time.html#section_user_guide_time_accuracy_and_resolution", null ]
    ] ],
    [ "Install", "page_user_guide_install.html", [
      [ "Supported systems", "page_user_guide_install.html#section_user_guide_build_installation_supported_systems", [
        [ "Supported operating systems.", "page_user_guide_install.html#section_user_guide_build_installation_supported_systems_1", null ],
        [ "Supported hardware", "page_user_guide_install.html#section_user_guide_build_installation_supported_systems_2", null ]
      ] ],
      [ "What's new in this release?", "page_user_guide_install.html#section_user_guide_build_installation_whats_new", null ],
      [ "Driver installation", "page_user_guide_install.html#section_user_guide_build_installation_driver_installation", null ],
      [ "Hardware installation", "page_user_guide_install.html#section_user_guide_build_installation_hardware", [
        [ "Hardware installation PCI Cards", "page_user_guide_install.html#section_user_guide_build_installation_hardware_1", null ]
      ] ],
      [ "Version Checking", "page_user_guide_install.html#section_user_guide_build_driver_version", null ]
    ] ],
    [ "Compiling and Linking", "page_user_guide_build.html", [
      [ "Compiling and Linking Your Code", "page_user_guide_build.html#section_user_guide_build_compiling_linking", null ]
    ] ],
    [ "Miscellaneous Topics", "page_user_guide_misc.html", [
      [ "Message Flags", "page_user_guide_misc.html#section_user_guide_misc_message_flags", null ],
      [ "Bit Rate Constants", "page_user_guide_misc.html#section_user_guide_misc_bitrate", null ],
      [ "Code and Mask Format", "page_user_guide_misc.html#section_user_guide_misc_code_and_mask", null ]
    ] ],
    [ "Code snippets", "page_code_snippets.html", [
      [ "canAccept / canSetAcceptanceFilter Example", "page_code_snippets.html#section_code_snippets_can_accept", null ],
      [ "canBusOff Example", "page_code_snippets.html#section_code_snippets_canbusoff", null ],
      [ "canBusOn Example", "page_code_snippets.html#section_code_snippets_canbuson", null ],
      [ "canClose Example", "page_code_snippets.html#section_code_snippets_canclose", null ],
      [ "canGetErrorText Example", "page_code_snippets.html#section_code_snippets_cangeterrortext", null ],
      [ "canInitializeLibrary Example", "page_code_snippets.html#section_code_snippets_caninitializelibrary", null ],
      [ "canOpenChannel Example", "page_code_snippets.html#section_code_snippets_canopenchannel", null ],
      [ "canRead Example", "page_code_snippets.html#section_code_snippets_canread", null ],
      [ "canSetBusParams Example", "page_code_snippets.html#section_code_snippets_cansetbusparams", null ],
      [ "canSetNotify Example", "page_code_snippets.html#section_code_snippets_cansetnotify", null ],
      [ "canGetChannelData Example", "page_code_snippets.html#section_code_snippets_cangetchanneldata", null ],
      [ "canWrite Example", "page_code_snippets.html#section_code_snippets_canwrite", null ],
      [ "canProbeVersion Example", "page_code_snippets.html#section_code_snippets_canprobeversion", null ],
      [ "canWaitForEvent Example", "page_code_snippets.html#section_code_snippets_canwaitforevent", null ],
      [ "kvTimeDomainXxx Example", "page_code_snippets.html#section_code_snippets_kvtimedomainxxx", null ],
      [ "kvScriptStart Example", "page_code_snippets.html#section_code_snippets_kvscriptstart", null ],
      [ "kvScriptEnvvarXxx Example", "page_code_snippets.html#section_code_snippets_kvscriptenvvarxxx", null ],
      [ "kvScriptSendEvent Example", "page_code_snippets.html#section_code_snippets_kvscriptsendevent", null ],
      [ "Bit Rate Examples", "page_code_snippets.html#section_code_snippets_bit_rate", null ]
    ] ],
    [ "Kvaser Support", "page_user_guide_support.html", null ]
];